// ==UserScript==
// @name Add-On 2fight
// @namespace http://www.2fighteur.com
// @description Rajoute des fonctionnalites au jeu 2fight.
// @include http://www.2fight.com/*
// ==/UserScript==


// --------------------------------------------------------------------
//
// Script By Win for 2fighteur
// Merci a Cary, sangio et Mazzu
// http://www.2fighteur.com
//
//
// Liste des fonctionnalites de la version actuelle :
//
// - Enleve le lien "Gratuit: Sortir TOUS tes persos de leurs villes".
// - Les pages "Capsules", "Objets"... ont maintenant la meme taille que les autres.
// - Efface les liens qui font sortir vos personnages afin de ne pas vous faire pieger (postes sur le forum, dans une signature ou envoye par un autre joueur par exemple).
// - Rajout d'un lien vers 2fighteur.
// - Supprime les liens de parrainage present sur le jeu.
// - Rajout des smileys lorsqu'on ecrit un message sur le forum.
// - Activez/deactivez les options une par une comme vous le souhaitez.
//
// En projet pour une nouvelle version :
//
// - Vous previens lorsqu'une mise a jours de l'Add-On est disponible.
//
// --------------------------------------------------------------------

// enregistrer une valeur dans localStorage
function GM_setValue(key, value) {
	chrome.extension.sendRequest({setValue: key + "=" + value});
}


function isElt(noderef) {
	return (noderef.nodeType == 1);
}

function getNextElt(noderef) {
	var tmp = noderef.nextSibling;
	while ((!!tmp) && (!isElt(tmp))) {
		tmp = tmp.nextSibling;
	}
	return tmp;
}

function getFirstElt(noderef) {
	var tmp = noderef.firstChild;
	if ((!!tmp) && (!isElt(tmp))) {
		return getNextElt(tmp);
	}
	return tmp;
}

function getPrevElt(noderef) {
	var tmp = noderef.previousSibling;
	while ((!!tmp) && (!isElt(tmp))) {
		tmp = tmp.previousSibling;
	}
	return tmp;
}

function getLastElt(noderef) {
	var tmp = noderef.lastChild;
	if ((!!tmp) && (!isElt(tmp))) {
		return getPrevElt(tmp);
	}
	return tmp;
}

function getParent(noderef, count) {
	if (!count) { // 0 ou undefined
		return noderef.parentNode;
	}

	var tmp = noderef;
	for (var i = 0; i < count; i++) {
		tmp = tmp.parentNode;
	}
	return tmp;
}

function getFirstTag(noderef, tagname) {
	var tmp = noderef.getElementsByTagName(tagname);
	return (tmp.length == 0) ? null : tmp[0];
}


// Creer un lien (seul le premier argument est obligatoire : url)
function createLink(url, txt, target) {
	var link = document.createElement("a");
	if (target) {
		link.target = target;
	}
	link.href = url;
	link.appendChild(document.createTextNode(txt ? txt : url));

	link.normalize();
	return link;
}

// Creer une section de menu
function createMenuSection(txt) {
	var menuSection = document.createElement("h4");
	menuSection.appendChild(document.createTextNode(txt));
	menuSection.normalize();
	return menuSection;
}

// Injecter des styles CSS dans la page.
function injectCSS(cssdata) {
	var head = document.getElementsByTagName("head")[0];
	var style = document.createElement("style");
	style.setAttribute("type", "text/css");
	style.innerHTML = cssdata;
	head.appendChild(style);
}

function getTextArea(n) {
	return document.getElementById("brd-wrap").getElementsByTagName("textarea")[n];
}


/**
  * From http://www.faqts.com/knowledge_base/view.phtml/aid/1052/fid/130
  */
function storeCaret(textEl) {
	if (textEl.createTextRange) {
		textEl.caretPos = document.selection.createRange().duplicate();
	}
}


/**
  * From http://www.massless.org/mozedit/
  */
function mozWrap(txtarea, open, close) {
	var selLength = (typeof(txtarea.textLength) == 'undefined') ? txtarea.value.length : txtarea.textLength;
	var selStart = txtarea.selectionStart;
	var selEnd = txtarea.selectionEnd;
	var scrollTop = txtarea.scrollTop;

	if (selEnd == 1 || selEnd == 2) {
		selEnd = selLength;
	}

	var s1 = (txtarea.value).substring(0,selStart);
	var s2 = (txtarea.value).substring(selStart, selEnd);
	var s3 = (txtarea.value).substring(selEnd, selLength);

	txtarea.value = s1 + open + s2 + close + s3;
	txtarea.selectionStart = selEnd + open.length + close.length;
	txtarea.selectionEnd = txtarea.selectionStart;
	txtarea.focus();
	txtarea.scrollTop = scrollTop;

	return;
}

function getmenucadre(menuid) {
	var menu = document.getElementById(menuid);
	if (!menu) {
		return null;
	}

	var divs = menu.getElementsByTagName("div");
	if (divs.length == 0) {
		return null;
	}
	return divs[0];
}

function add2fighteurlink() {
	var cadre = getmenucadre("tm_amis");
	if (!cadre) {
		return;
	}

	var nextentry = getFirstElt(cadre);
	while ((!!nextentry) && (nextentry.className != "last")) {
		nextentry = getNextElt(nextentry);
	}

	var titreAlliance = document.createElement("h4");
	titreAlliance.appendChild(document.createTextNode("Alliance"));
    titreAlliance.normalize();

	var linkBS = document.createElement("a");
	linkBS.target = "_blank";
    linkBS.href = "http://ballsuprem.forumactif.net/forum.htm";
    linkBS.appendChild(document.createTextNode("Clan BS"));
    linkBS.normalize();

	var linkCDP = document.createElement("a");
	linkCDP.target = "_blank";
    linkCDP.href = "http://cdp-clan2fight.forumactif.net/forum.htm";
    linkCDP.appendChild(document.createTextNode("Clan CDP"));
    linkCDP.normalize();

	var linkLIGHT = document.createElement("a");
	linkLIGHT.target = "_blank";
    linkLIGHT.href = "http://light-of-shadow.forumactif.net/forum.htm";
    linkLIGHT.appendChild(document.createTextNode("Clan LIGHT"));
    linkLIGHT.normalize();

	var linkSR = document.createElement("a");
	linkSR.target = "_blank";
    linkSR.href = "http://secktsrevenge-2fight.forumactif.com/forum.htm";
    linkSR.appendChild(document.createTextNode("Clan SR"));
    linkSR.normalize();

	var linkTPL = document.createElement("a");
	linkTPL.target = "_blank";
    linkTPL.href = "http://talk-play-love.forumactif.com/forum.htm";
    linkTPL.appendChild(document.createTextNode("Clan TPL"));
    linkTPL.normalize();

    if (!nextentry) {
		cadre.appendChild(titreAlliance);
        cadre.appendChild(linkBS);
        cadre.appendChild(linkCDP);
        cadre.appendChild(linkLIGHT);
        cadre.appendChild(linkSR);
        cadre.appendChild(linkTPL);
    } else {
        cadre.insertBefore(titreAlliance, nextentry);
        cadre.insertBefore(linkBS, nextentry);
        cadre.insertBefore(linkCDP, nextentry);
        cadre.insertBefore(linkLIGHT, nextentry);
        cadre.insertBefore(linkSR, nextentry);
        cadre.insertBefore(linkTPL, nextentry);
    }

	injectCSS('#topmenu div#tm_amis div.cadre a { min-height: 14px;');
}

(function () {

	var path = document.location.pathname;
	var divAllAll = document.getElementById("AllAll");
	if(!divAllAll) {
		 // on est sur une image, un code source... ou le forum
		if(path.indexOf("/forums/") < 0) {
			// on est sur une image, un code source... l'add-on ne s'applique pas
			return;
		}
	}

	// lien2fighteur
	chrome.extension.sendRequest({valueOf: "lien2fighteur"}, function(response) {
		var e, valeur = response.value;
		if(valeur == null || valeur == "true") {
			try {
				// Insertion d'un lien vers 2fighteur dans le menu "Amis"
				add2fighteurlink();
			} catch (e) {
				alert("Add-On 2fight erreur (4) :\n" + e);
			}
		}
	});

})();

